#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os, os.path,shutil

### configuration ###

#path to which the camera is mounted
cameraMount="/media/CANON/"

#path were the photos should be moved to
DESTDIR = "/media/Elements1/University/camera/"

#path where the photos are in the camera (you might need to change this if you took more than 1000 photos)
PICDIR = cameraMount + "DCIM/100CANON/"

#the number, and hte course folder to move it to
course= []
course.insert(0, "infi")
course.insert(1,"quantum1")
course.insert(2,"dust")
course.insert(3, "lab2")
course.insert(4, "oop")

#path where CHDK saves the logs in the camera
startDir = cameraMount + "CHDK/LOGS/"

### End of configuration ###
NODATA = "nodata"
def ensure_dir(f):
    if not os.path.exists(f):
        os.makedirs(f)

def getdata(fullpath):
  pic_number = os.path.basename(fullpath)[4:8] #picture number from file
  picspath=["",""]
  picspath[0] = PICDIR + "IMG_" + pic_number + ".JPG"
  picspath[1] = PICDIR + "img_" + pic_number + ".jpg"
  for pic_path in picspath:
    if os.path.isfile(pic_path): #we found an image
      #print pic_path +  " exists"
      f = open(fullpath,"r")
      data =  f.readline()
      data =  f.readline()
      data = data.split(" ")
      f.close()
      data.append(pic_path)
      return data
    else:
      return NODATA
    #print pic_path +  " does not exist"
  
  """
  while f:
    line = f.read()
    print line
  """

  return False
  
  
#make sure course dirs exist
for i in course:
  ensure_dir(DESTDIR+i)

directories = [startDir]
while len(directories)>0:
    directory = directories.pop()
    for name in os.listdir(directory):
        fullpath = os.path.join(directory,name)
        if os.path.isfile(fullpath):
            data = getdata(fullpath)                # That's a file. Do
	    #print data
	    if (data != NODATA):
	      course_input = data[0]
	      week_input = data[1]
	      pic_path = data[4]
	      #print data
	      #print course_input
	      print week_input + " " +  course[int(course_input)] + " " + pic_path
	      dir_input = DESTDIR + course[int(course_input)] + "/pics/week" + week_input + "/"
	      ensure_dir(dir_input)
	      print "copying " + os.path.basename(pic_path)
	      dest = dir_input + os.path.basename(pic_path)
	      shutil.move(pic_path, dest)

	    
	    
	    
	    
        elif os.path.isdir(fullpath):
            directories.append(fullpath)  # It's a directory, store it.
