#!/usr/bin/env bash

#this temp dir is where the PDF are generated, it can reach gigabytes! so its recommended to set it to a place with space
export TMPDIR=/tmp

#path where the images are saved
PICS_DIR= /media/Elements1/University/camera

#Convert -verbose -limit memory 100mb -limit map 100mb *.jpg -adjoin 000.pdf



function check_convert()
{
  DIR=$@
  CURRENTLS=`find $DIR -maxdepth 1 -type f -print0`
  TMP1=${DIR%/*}
  COURSE=`basename ${TMP1%/*}`
  PDFPATH=$DIR/../../$COURSE"_"`basename $DIR`.pdf
  LSFILE=$DIR/convert_list.txt
  OLDLS=$(cat $LSFILE)
  if [[ ! -e $LSFILE ]]  || [[ "${CURRENTLS}" != "$(<$LSFILE)" ]] ; then
    echo converting $DIR
    convert -verbose  -limit memory 100mb -limit map 100mb $DIR/*.[jJ][pP][gG] -adjoin -resize 1024x768 $PDFPATH
  else
    echo "Not generating $DIR"
  fi
  echo "$CURRENTLS" > $LSFILE
}


function ProcessDir
{
  # Process each argument
  for f in $(find "$@" -type d)
  do
    check_convert $f
  done
}

ProcessDir $PICS_DIR